1 #!/bin/sh -- # no runable script, just for vi
5 # we all like colorful messages
6 if expr match
"$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev
/null
&& \
7 expr match
"$(readlink -f /proc/$$/fd/2)" '/dev/pts/[0-9]\+' > /dev
/null
; then
8 CERROR
="\e[1;31m" # red
9 CWARNING
="\e[1;33m" # yellow
10 CMSG
="\e[1;32m" # green
11 CINFO
="\e[1;96m" # light blue
12 CDEBUG
="\e[1;94m" # blue
13 CNORMAL
="\e[0;39m" # default system console color
14 CDONE
="\e[1;32m" # green
15 CPASS
="\e[1;32m" # green
16 CFAIL
="\e[1;31m" # red
17 CCMD
="\e[1;35m" # pink
20 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
21 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgmsg
() { echo "${CMSG}$1${CNORMAL}" >&2; }
23 msginfo
() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgdone
() { echo "${CDONE}DONE${CNORMAL}" >&2; }
26 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
27 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
28 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
29 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
32 echo -n "${CINFO}$1${CCMD} " >&2;
33 echo -n "$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} " >&2;
35 if [ -n "$1" ]; then shift; else break; fi
37 echo -n "…${CNORMAL} " >&2;
39 msgpass
() { echo "${CPASS}PASS${CNORMAL}" >&2; }
40 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
41 msgfail
() { echo "${CFAIL}FAIL${CNORMAL}" >&2; EXIT_CODE
=$((EXIT_CODE+1)); }
43 # enable / disable Debugging
44 MSGLEVEL
=${MSGLEVEL:-3}
45 if [ $MSGLEVEL -le 0 ]; then
48 if [ $MSGLEVEL -le 1 ]; then
52 if [ $MSGLEVEL -le 2 ]; then
56 msgpass
() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
57 msgskip
() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
58 if [ -n "$CFAIL" ]; then
59 msgfail
() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
61 msgfail
() { echo -n " ###FAILED###" >&2; }
64 if [ $MSGLEVEL -le 3 ]; then
68 if [ $MSGLEVEL -le 4 ]; then
73 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
74 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
75 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
76 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
77 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
80 echo "${CDONE}DONE${CNORMAL}" >&2;
85 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
86 if [ -f .
/aptconfig.conf
]; then
87 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
88 elif [ -f ..
/aptconfig.conf
]; then
89 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
91 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
94 aptconfig
() { runapt apt
-config $
*; }
95 aptcache
() { runapt apt
-cache $
*; }
96 aptcdrom
() { runapt apt
-cdrom $
*; }
97 aptget
() { runapt apt
-get $
*; }
98 aptftparchive
() { runapt apt
-ftparchive $
*; }
99 aptkey
() { runapt apt
-key $
*; }
100 aptmark
() { runapt apt
-mark $
*; }
102 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir
--force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log $
*
105 if [ -f .
/aptconfig.conf
]; then
106 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
107 elif [ -f ..
/aptconfig.conf
]; then
108 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
110 LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
115 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which gdb) ${BUILDDIRECTORY}/$1
119 # error if we about to overflow, but ...
120 # "255 failures ought to be enough for everybody"
121 if [ $EXIT_CODE -gt 255 ]; then
122 msgdie
"Total failure count $EXIT_CODE too big"
124 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
128 CURRENTTRAP
="$CURRENTTRAP $1"
129 trap "$CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
133 TMPWORKINGDIRECTORY
=$(mktemp -d)
134 TESTDIRECTORY
=$(readlink -f $(dirname $0))
135 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
136 BUILDDIRECTORY
="${TESTDIRECTORY}/../../build/bin"
137 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
138 local OLDWORKINGDIRECTORY
=$(pwd)
139 addtrap
"cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
140 cd $TMPWORKINGDIRECTORY
141 mkdir rootdir aptarchive keys
143 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
144 mkdir -p var
/cache var
/lib var
/log
145 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
146 touch var
/lib
/dpkg
/available
148 ln -s ${BUILDDIRECTORY}/methods usr
/lib
/apt
/methods
150 local PACKAGESFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
151 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
152 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
154 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
155 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
156 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive
/Sources
158 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys
/
159 ln -s ${TMPWORKINGDIRECTORY}/keys
/joesixpack.pub rootdir
/etc
/apt
/trusted.gpg.d
/joesixpack.gpg
160 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
161 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
162 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
163 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
164 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
165 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
166 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
167 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
168 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
169 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
170 if ! $(which dpkg) --assert-multi-arch 2>&1 > /dev
/null
; then
171 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf
# Added to test multiarch before dpkg is ready for it…
173 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
174 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
176 export PATH
="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
181 if [ "$1" = "native" -o -z "$1" ]; then
182 eval `aptconfig shell ARCH APT::Architecture`
183 if [ -n "$ARCH" ]; then
186 dpkg
--print-architecture
194 echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
197 configarchitecture
() {
198 local CONFFILE
=rootdir
/etc
/apt
/apt.conf.d
/01multiarch.conf
200 echo "APT::Architecture \"$(getarchitecture $1)\";" > $CONFFILE
202 while [ -n "$1" ]; do
203 echo "APT::Architectures:: \"$(getarchitecture $1)\";" >> $CONFFILE
210 if [ ! -e rootdir
/var
/lib
/dpkg
/status
]; then
211 local STATUSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
212 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
213 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
215 echo -n > rootdir/var/lib/dpkg/status
218 if $(which dpkg) --assert-multi-arch 2>&1 > /dev/null; then
219 local ARCHS="$(getarchitectures)"
220 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
221 DPKGARCH="$(dpkg --print-architecture)"
222 for ARCH in ${ARCHS}; do
223 if [ "${ARCH}" != "${DPKGARCH}" ]; then dpkg --add-architecture ${ARCH}; fi
225 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
226 # dpkg doesn't really check the version as long as it is fully installed,
227 # but just to be sure we choose one above the required version
228 insertinstalledpackage 'dpkg' "all
" '1.16.2+fake'
234 setupsimplenativepackage() {
238 local RELEASE="${4:-unstable}"
239 local DEPENDENCIES="$5"
240 local DESCRIPTION="$6"
241 local SECTION="${7:-others}"
243 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
246 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
248 local BUILDDIR=incoming/${NAME}-${VERSION}
249 mkdir -p ${BUILDDIR}/debian/source
251 echo "* most suckless software product ever
" > FEATURES
252 test -e debian/copyright || echo "Copyleft by Joe Sixpack
$(date +%Y)" > debian/copyright
253 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency
=low
257 -- Joe Sixpack
<joe@example.org
> $(date -R)" > debian/changelog
258 test -e debian/control || echo "Source
: $NAME
261 Maintainer
: Joe Sixpack
<joe@example.org
>
262 Build
-Depends: debhelper
(>= 7)
263 Standards
-Version: 3.9.1
265 Package
: $NAME" > debian/control
266 if [ "$ARCH" = 'all' ]; then
267 echo "Architecture
: all
" >> debian/control
269 echo "Architecture
: any
" >> debian/control
271 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
272 if [ -z "$DESCRIPTION" ]; then
273 echo "Description
: an autogenerated dummy
${NAME}=${VERSION}/${RELEASE}
274 If you
find such a package installed on your system
,
275 YOU did something horribly wrong
! They are autogenerated
276 und used only by testcases
for APT and surf no other propose…
" >> debian/control
278 echo "Description
: $DESCRIPTION" >> debian/control
280 test -e debian/compat || echo "7" > debian/compat
281 test -e debian/source/format || echo "3.0 (native
)" > debian/source/format
282 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
286 buildsimplenativepackage() {
290 local RELEASE="${4:-unstable}"
291 local DEPENDENCIES="$5"
292 local DESCRIPTION="$6"
293 local SECTION="${7:-others}"
294 local PRIORITY="${8:-optional}"
296 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
299 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
301 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
303 msgninfo "Build package
${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}…
"
304 mkdir -p $BUILDDIR/debian/source
305 echo "* most suckless software product ever
" > ${BUILDDIR}/FEATURES
307 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
309 echo "Copyleft by Joe Sixpack
$(date +%Y)" > ${BUILDDIR}/debian/copyright
310 echo "$NAME ($VERSION) $RELEASE; urgency
=low
314 -- Joe Sixpack
<joe@example.org
> $(date -R)" > ${BUILDDIR}/debian/changelog
318 Maintainer
: Joe Sixpack
<joe@example.org
>
319 Standards
-Version: 3.9.3" > ${BUILDDIR}/debian/control
320 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
321 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
323 Package
: $NAME" >> ${BUILDDIR}/debian/control
325 if [ "$ARCH" = 'all' ]; then
326 echo "Architecture
: all
" >> ${BUILDDIR}/debian/control
328 echo "Architecture
: any
" >> ${BUILDDIR}/debian/control
330 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
331 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
332 if [ -z "$DESCRIPTION" ]; then
333 echo "Description
: an autogenerated dummy
${NAME}=${VERSION}/${RELEASE}
334 If you
find such a package installed on your system
,
335 YOU did something horribly wrong
! They are autogenerated
336 und used only by testcases
for APT and surf no other propose…
" >> ${BUILDDIR}/debian/control
338 echo "Description
: $DESCRIPTION" >> ${BUILDDIR}/debian/control
341 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
342 (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' \
344 echo "pool
/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
345 # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
346 # gpg --yes --no-default-keyring --secret-keyring ./keys/joesixpack.sec \
347 # --keyring ./keys/joesixpack.pub --default-key 'Joe Sixpack' \
348 # --clearsign -o "${BUILDDIR}/..
/${SRC}.sign
" "${BUILDDIR}/..
/$SRC"
349 # mv "${BUILDDIR}/..
/${SRC}.sign
" "${BUILDDIR}/..
/$SRC"
353 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
354 rm -rf ${BUILDDIR}/debian
/tmp
355 mkdir -p ${BUILDDIR}/debian
/tmp
/DEBIAN
${BUILDDIR}/debian
/tmp
/usr
/share
/doc
/${NAME} ${BUILDDIR}/debian
/tmp
/usr
/bin
356 cp ${BUILDDIR}/debian
/copyright
${BUILDDIR}/debian
/changelog
${BUILDDIR}/FEATURES
${BUILDDIR}/debian
/tmp
/usr
/share
/doc
/${NAME}
357 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian
/tmp
/usr
/bin
/${NAME}-${arch}
358 (cd ${BUILDDIR}; dpkg
-gencontrol -DArchitecture=$arch)
359 (cd ${BUILDDIR}/debian
/tmp
; md5sum $(find usr/ -type f) > DEBIAN
/md5sums
)
361 dpkg
-deb --build ${BUILDDIR}/debian
/tmp
${BUILDDIR}/..
2> /dev
/null
> /dev
/null
362 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/..
/${RELEASE}.
${DISTSECTION}.pkglist
365 mkdir -p ${BUILDDIR}/..
/${NAME}_
${VERSION}
366 cp ${BUILDDIR}/debian
/changelog
${BUILDDIR}/..
/${NAME}_
${VERSION}/
367 cp ${BUILDDIR}/debian
/changelog
${BUILDDIR}/..
/${NAME}_
${VERSION}.changelog
376 local ARCH
=$(getarchitecture $4)
377 msgninfo
"Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
379 if [ "$ARCH" = "all" ]; then
380 ARCH
="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
382 local BUILT
="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
383 local PKGS
="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
384 local SRCS
="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
387 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.pkglist
390 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.srclist
396 if [ -d incoming
]; then
397 buildaptarchivefromincoming $
*
399 buildaptarchivefromfiles $
*
403 createaptftparchiveconfig
() {
404 local ARCHS
="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
405 if [ -z "$ARCHS" ]; then
406 # the pool is empty, so we will operate on faked packages - let us use the configured archs
407 ARCHS
="$(getarchitectures)"
410 ArchiveDir "' >> ftparchive.conf
411 echo -n $(readlink -f .) >> ftparchive.conf
413 CacheDir "' >> ftparchive.conf
414 echo -n $(readlink -f ..) >> ftparchive.conf
416 FileListDir "' >> ftparchive.conf
417 echo -n $(readlink -f pool/) >> ftparchive.conf
421 Packages::Compress ". gzip bzip2 lzma xz";
422 Sources::Compress ". gzip bzip2 lzma xz";
423 Contents::Compress ". gzip bzip2 lzma xz";
424 Translation::Compress ". gzip bzip2 lzma xz";
425 LongDescription "false";
429 SrcDirectory "pool/";
435 Label "apttestcases";
437 Description "repository with dummy packages";
438 Architectures "' >> ftparchive.conf
439 echo -n "$ARCHS" >> ftparchive.conf
443 };' >> ftparchive.conf
444 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
445 echo -n 'tree "dists/' >> ftparchive.conf
446 echo -n "$DIST" >> ftparchive.conf
448 Architectures "' >> ftparchive.conf
449 echo -n "$ARCHS" >> ftparchive.conf
451 FileList "' >> ftparchive.conf
452 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
454 SourceFileList "' >> ftparchive.conf
455 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
457 Sections "' >> ftparchive.conf
458 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
460 };' >> ftparchive.conf
464 buildaptftparchivedirectorystructure
() {
465 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
466 for DIST
in $DISTS; do
467 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
468 for SECTION
in $SECTIONS; do
469 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
470 for ARCH
in $ARCHS; do
471 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
473 mkdir -p dists
/${DIST}/${SECTION}/source
474 mkdir -p dists
/${DIST}/${SECTION}/i18n
484 local DEPENDENCIES
="$5"
485 local PRIORITY
="${6:-optional}"
487 for arch
in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
488 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
489 ARCHS
="$(getarchitectures)"
493 for BUILDARCH
in $ARCHS; do
494 local PPATH
="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
495 mkdir -p $PPATH aptarchive
/dists
/${RELEASE}/main
/source
496 touch aptarchive
/dists
/${RELEASE}/main
/source
/Sources
497 local FILE
="${PPATH}/Packages"
502 Maintainer: Joe Sixpack <joe@example.org>" >> $FILE
503 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
504 echo "Version: $VERSION
505 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
506 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
507 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
508 If you find such a package installed on your system,
509 YOU did something horribly wrong! They are autogenerated
510 und used only by testcases for APT and surf no other propose…
521 local DEPENDENCIES
="$5"
523 local SPATH
="aptarchive/dists/${RELEASE}/main/source"
525 local FILE
="${SPATH}/Sources"
529 Maintainer: Joe Sixpack <joe@example.org>
530 Architecture: $ARCH" >> $FILE
531 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
533 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
534 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz
538 insertinstalledpackage
() {
542 local DEPENDENCIES
="$4"
543 local PRIORITY
="${5:-optional}"
544 local STATUS
="${6:-install ok installed}"
545 local FILE
='rootdir/var/lib/dpkg/status'
546 local INFO
='rootdir/var/lib/dpkg/info'
547 for arch
in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
553 Maintainer: Joe Sixpack <joe@example.org>
554 Version: $VERSION" >> $FILE
555 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
556 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
557 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/installed
558 If you find such a package installed on your system,
559 YOU did something horribly wrong! They are autogenerated
560 und used only by testcases for APT and surf no other propose…
562 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
563 echo -n > ${INFO}/${NAME}:${arch}.list
565 echo -n > ${INFO}/${NAME}.list
571 buildaptarchivefromincoming
() {
572 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
574 [ -e pool
] || ln -s ..
/incoming pool
575 [ -e ftparchive.conf
] || createaptftparchiveconfig
576 [ -e dists
] || buildaptftparchivedirectorystructure
577 msgninfo
"\tGenerate Packages, Sources and Contents files… "
578 aptftparchive
-qq generate ftparchive.conf
584 buildaptarchivefromfiles
() {
585 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
586 find aptarchive
-name 'Packages' -o -name 'Sources' | while read line
; do
587 msgninfo
"\t${line} file… "
588 cat ${line} | gzip > ${line}.gz
589 cat ${line} | bzip2 > ${line}.bz2
590 cat ${line} | xz
--format=lzma
> ${line}.lzma
591 cat ${line} | xz
> ${line}.xz
597 # can be overridden by testcases for their pleasure
598 getcodenamefromsuite
() { echo -n "$1"; }
599 getreleaseversionfromsuite
() { true
; }
600 getlabelfromsuite
() { true
; }
602 generatereleasefiles
() {
603 # $1 is the Date header and $2 is the ValidUntil header to be set
604 # both should be given in notation date/touch can understand
605 msgninfo
"\tGenerate Release files… "
606 if [ -e aptarchive
/dists
]; then
607 for dir
in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
608 local SUITE
="$(echo "$dir" | cut -d'/' -f 4)"
609 local CODENAME
="$(getcodenamefromsuite $SUITE)"
610 local VERSION
="$(getreleaseversionfromsuite $SUITE)"
611 local LABEL
="$(getlabelfromsuite $SUITE)"
612 if [ -n "$VERSION" ]; then
613 VERSION
="-o APT::FTPArchive::Release::Version=${VERSION}"
615 if [ -n "$LABEL" ]; then
616 LABEL
="-o APT::FTPArchive::Release::Label=${LABEL}"
618 aptftparchive
-qq release
$dir \
619 -o APT
::FTPArchive
::Release
::Suite
="${SUITE}" \
620 -o APT
::FTPArchive
::Release
::Codename
="${CODENAME}" \
623 | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
624 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
626 NotAutomatic: yes' $dir/Release
628 if [ -n "$1" -a "$1" != "now" ]; then
629 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
633 Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
637 aptftparchive
-qq release .
/aptarchive
| sed -e '/0 Release$/ d' > aptarchive
/Release
# remove the self reference
639 if [ -n "$1" -a "$1" != "now" ]; then
640 for release
in $(find ./aptarchive -name 'Release'); do
641 touch -d "$1" $release
647 setupdistsaptarchive
() {
648 local APTARCHIVE
=$(readlink -f ./aptarchive)
649 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
650 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
651 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
652 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
653 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
654 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
655 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
660 setupflataptarchive
() {
661 local APTARCHIVE
=$(readlink -f ./aptarchive)
662 if [ -f ${APTARCHIVE}/Packages
]; then
663 msgninfo
"\tadd deb sources.list line… "
664 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
667 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
669 if [ -f ${APTARCHIVE}/Sources
]; then
670 msgninfo
"\tadd deb-src sources.list line… "
671 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
674 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
680 if [ -e aptarchive
/dists
]; then
686 msgninfo
"\tSync APT's cache with the archive… "
692 local SIGNER
="${1:-Joe Sixpack}"
693 msgninfo
"\tSign archive with $SIGNER key… "
695 for KEY
in $(find keys/ -name '*.sec'); do
696 SECKEYS
="$SECKEYS --secret-keyring $KEY"
699 for KEY
in $(find keys/ -name '*.pub'); do
700 PUBKEYS
="$PUBKEYS --keyring $KEY"
702 for RELEASE
in $(find aptarchive/ -name Release); do
703 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg
${RELEASE}
704 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
709 changetowebserver
() {
710 if which weborf
> /dev
/null
; then
711 weborf
-xb aptarchive
/ 2>&1 > /dev
/null
&
713 elif which gatling
> /dev
/null
; then
715 gatling
-p 8080 -F -S 2>&1 > /dev
/null
&
718 elif which lighttpd
> /dev
/null
; then
719 echo "server.document-root = \"$(readlink -f ./aptarchive)\"
721 server.stat-cache-engine = \"disable\"" > lighttpd.conf
722 lighttpd
-t -f lighttpd.conf
>/dev
/null
|| msgdie
'Can not change to webserver: our lighttpd config is invalid'
723 lighttpd
-D -f lighttpd.conf
2>/dev
/null
>/dev
/null
&
726 msgdie
'You have to install weborf or lighttpd first'
729 local APTARCHIVE
="file://$(readlink -f ./aptarchive)"
730 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
731 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
737 mkdir -p rootdir
/media
/cdrom
/.disk
738 local CD
="$(readlink -f rootdir/media/cdrom)"
739 echo "acquire::cdrom::mount \"${CD}\";" > rootdir
/etc
/apt
/apt.conf.d
/00cdrom
740 echo 'acquire::cdrom::autodetect 0;' >> rootdir
/etc
/apt
/apt.conf.d
/00cdrom
741 echo -n "$1" > ${CD}/.disk
/info
742 if [ ! -d aptarchive
/dists
]; then
743 msgdie
'Flat file archive cdroms can not be created currently'
746 mv aptarchive
/dists
$CD
747 ln -s "$(readlink -f ./incoming)" $CD/pool
748 find rootdir
/etc
/apt
/sources.list.d
/ -name 'apt-test-*.list' -delete
752 local DIFFTEXT
="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
753 if [ -n "$DIFFTEXT" ]; then
765 msgtest
"Test for correctness of file" "$FILE"
767 echo -n "" | checkdiff
$FILE - && msgpass
|| msgfail
769 echo "$*" | checkdiff
$FILE - && msgpass
|| msgfail
774 msgtest
"Test for no output of" "$*"
775 test -z "$($* 2>&1)" && msgpass
|| msgfail
779 local COMPAREFILE
=$(mktemp)
780 addtrap
"rm $COMPAREFILE;"
781 echo "$1" > $COMPAREFILE
783 msgtest
"Test for equality of" "$*"
784 $
* 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
788 local COMPAREFILE1
=$(mktemp)
789 local COMPAREFILE2
=$(mktemp)
790 local COMPAREAGAINST
=$(mktemp)
791 addtrap
"rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
792 echo "$1" > $COMPAREFILE1
793 echo "$2" > $COMPAREFILE2
795 msgtest
"Test for equality OR of" "$*"
796 $
* 2>&1 1> $COMPAREAGAINST
797 (checkdiff
$COMPAREFILE1 $COMPAREAGAINST 1> /dev
/null
||
798 checkdiff
$COMPAREFILE2 $COMPAREAGAINST 1> /dev
/null
) && msgpass
||
799 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
800 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
805 local VIRTUAL
="N: Can't select versions from package '$1' as it is purely virtual"
808 while [ -n "$1" ]; do
810 N: Can't select versions from package '$1' as it is purely virtual"
811 PACKAGE
="${PACKAGE} $1"
814 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
816 N: No packages found"
817 local COMPAREFILE
=$(mktemp)
818 addtrap
"rm $COMPAREFILE;"
819 local ARCH
="$(getarchitecture 'native')"
820 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
821 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
825 msgtest
"Test for non-existent packages" "apt-cache show $*"
826 local SHOWPKG
="$(aptcache show $* 2>&1 | grep '^Package: ')"
827 if [ -n "$SHOWPKG" ]; then
836 testdpkginstalled
() {
837 msgtest
"Test for correctly installed package(s) with" "dpkg -l $*"
838 local PKGS
="$(dpkg -l $* 2>/dev/null | grep '^i' | wc -l)"
839 if [ "$PKGS" != $# ]; then
841 dpkg
-l $
* | grep '^[a-z]'
848 testdpkgnotinstalled
() {
849 msgtest
"Test for correctly not-installed package(s) with" "dpkg -l $*"
850 local PKGS
="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
851 if [ "$PKGS" != 0 ]; then
853 dpkg
-l $
* | grep '^[a-z]'
861 local COMPAREFILE
=$(mktemp)
862 addtrap
"rm $COMPAREFILE;"
864 msgtest
'Test for correctly marked as auto-installed' "$*"
865 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
867 msgtest
'Test for correctly marked as auto-installed' 'no package'
868 echo -n > $COMPAREFILE
870 aptmark showauto
2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
874 echo "STOPPED execution. Press enter to continue"